	SUBROUTINE DISTRN (GAMMA, BETA, COSPHI, FCN, FCNPHI, FCNGAM )

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	                    DOUBLE POWER LAW                             C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C    Purpose -     This routine calculates the value of the 
C       distribution function and its first derivatives by GAMMA and 
C       by PHI.  This information is user specified.  The distribution
C       function is normalized so that 2*PI*Int(dGAMMA)Int(dCOSPHI)
C       FCN = 1.

	IMPLICIT NONE

	INCLUDE		'GETGSE.INC'

	REAL*8		GAMMA, BETA, COSPHI, FCN, FCNPHI, FCNGAM, K

	REAL*8		DENOMA, DENOMB, DENOM, GAMLOW, GAMHIGH, GAMBRK

	COMMON		/DISTLIMS/GAMLOW, GAMHIGH, GAMBRK

C			Obtain normalization coefficient, K
	  DENOMA = ((GAMBRK-1.0D0)**(1.0D0-P))-((GAMLOW-1.0D0)**(1.0D0-P))
	  DENOMA = DENOMA*(1.0D0-Q)
	  DENOMB = ((GAMHIGH-1.0D0)**(1.0D0-Q))-((GAMBRK-1)**(1.0D0-Q))                                                                                                        
	  DENOMB = DENOMB*(1.0D0-P)*((GAMBRK-1.0D0)**(Q-P))
	  DENOM = DENOMA+DENOMB
	  K = (1.0D0-Q-P+(P*Q))/(DENOM*(4.0D+00*PI))

C                 Calculate value of distribution function at GAMMA
C                 and COSPHI, for GAMMA between GAMMIN and GAMMAC, or
C				for GAMMA between GAMMAC and GAMMAX.
		IF(GAMMA .GE. GAMLOW .AND. GAMMA .LE. GAMBRK)THEN
			FCN = K*((GAMMA-1.0D+00)**(-P))

C                  Calculate value of derivative by PHI of the 
C                  distribution function, and evaluate at GAMMA
C                  and COSPHI.
              FCNPHI =  0.0D+00

C                  Calculate value of the first derivative  by GAMMA 
C                  of the distribution function, and evaluate at 
C                  GAMMA and COSPHI.
              FCNGAM = (-P) * FCN / (GAMMA - 1.0D+00)
		ELSEIF(GAMMA .GT. GAMBRK .AND. GAMMA .LE. GAMHIGH)THEN
			FCN = K*((GAMBRK-1.0D+00)**(Q-P)*(GAMMA-1.0D+00)**(-Q))
	
C                  Calculate value of derivative by PHI of the 
C                  distribution function, and evaluate at GAMMA
C                  and COSPHI.
              FCNPHI =  0.0D+00

C                  Calculate value of the first derivative  by GAMMA 
C                  of the distribution function, and evaluate at 
C                  GAMMA and COSPHI.
              FCNGAM = (-Q) * FCN / (GAMMA - 1.0D+00)
		ENDIF
	RETURN
	END